/***************************************************************************
 *   Copyright (C) 2004 by Hans Oischinger                                 *
 *   hans.oischinger@kdemail.net                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Steet, Fifth Floor, Boston, MA 02110-1301, USA.             *
 ***************************************************************************/
#include "animatedenum.h"

#include "enumeration.h"

// Visitors
#include "visitors/avisitor.h"


AnimatedEnum::AnimatedEnum()
    : Attribute( Attribute::ATTR_ENUM )
{
  m_baseVal = new Enumeration();
  m_animVal = new Enumeration();
}

AnimatedEnum::~AnimatedEnum()
{
  delete m_baseVal;
  delete m_animVal;
}

AnimatedEnum::AnimatedEnum( const AnimatedEnum & )
  : Attribute( Attribute::ATTR_ENUM )
{
  m_baseVal = new Enumeration();
  m_animVal = new Enumeration();
}

AnimatedEnum& AnimatedEnum::operator=(const AnimatedEnum &other)
{
  Attribute::operator=(other);
  *m_baseVal = other.baseVal();
  *m_animVal = other.animVal();

  return *this;
}

Attribute* AnimatedEnum::clone()
{
  AnimatedEnum* retElem = new AnimatedEnum();
  *retElem = *this;
  return ( retElem );
}

/**
   * Overrides default isValid() method and delegate request to baseVal
   * @return 
 */
bool AnimatedEnum::isValid( ) const
{
  return m_baseVal->isValid();
}

void AnimatedEnum::accept( AVisitor &a )
{
  a.visit(*this);
}
